<?php 
/**
 * Dashboard widgets
 */

// Remove default widgets

remove_action( 'welcome_panel', 'wp_welcome_panel' );

add_action( 'wp_dashboard_setup', 'my_remove_dashboard_widgets' );
function my_remove_dashboard_widgets() {
	//main:
	remove_meta_box( 'dashboard_browser_nag', 'dashboard', 'normal' );
	remove_meta_box( 'dashboard_right_now', 'dashboard', 'normal' );
	remove_meta_box( 'dashboard_recent_comments', 'dashboard', 'normal' );
	remove_meta_box( 'dashboard_incoming_links', 'dashboard', 'normal' );
	remove_meta_box( 'dashboard_plugins', 'dashboard', 'normal' );
	
	//side:
	remove_meta_box( 'dashboard_quick_press', 'dashboard', 'side' );
	remove_meta_box( 'dashboard_recent_drafts', 'dashboard', 'side' );
	remove_meta_box( 'dashboard_primary', 'dashboard', 'side' );
	remove_meta_box( 'dashboard_secondary', 'dashboard', 'side' );
	
}

// Add new widgets
add_action( 'wp_dashboard_setup', 'my_add_dashboard_widgets' );
function my_add_dashboard_widgets() {
	wp_add_dashboard_widget('widget_featured_posts', 'Homepage Featured Posts', 'render_featured_widget' );
}
function render_featured_widget() {
	?>
	<form action="options.php" method="POST">
		<?php settings_errors(); ?>
		<?php settings_fields( 'featured-settings-group' ); ?>
		<?php do_settings_sections( 'my-featured-settings' ); ?>
		<?php submit_button(); ?>
	</form>
	<?php
}

// Register settings, sections and fields for the Featured Posts Widget
add_action('admin_init', 'my_register_featured_posts_settings');
function my_register_featured_posts_settings() {
	// register setting - featured posts
	register_setting( 'featured-settings-group', 'my_featured_posts' );

	// fetch saved settings
	$featured_posts = get_option( 'my_featured_posts' );
	
	// add sections and fields
	add_settings_section( 'my-featured-section', '', 'render_settings_section_featured', 'my-featured-settings' );
	
	add_settings_field( 'my-settings-feat1', 'Article 1', 'render_settings_select_box', 'my-featured-settings', 'my-featured-section', array( 'name' => 'my_featured_posts[0]', 'key' => 0, 'value' => $featured_posts ) );
	//and so on...

}


// Render sections
function render_settings_section_featured() {
	// some text, id needed.
}

// Render fields
function render_settings_select_box( $args ) {
	$values = $args['value'];
	
	if( isset( $values[ $args['key'] ] ) ) {
		$featured = $values[ $args['key'] ];
	} else {
		$featured = 0;
	}
	
	echo '<select name="'.$args['name'].'">';
		echo '<option value="0" '. selected( 0 , $featured ) .'>---</option>';
	foreach ( get_posts( array( 'posts_per_page' => -1 ) ) as $post ) {
		if( isset( $post->ID ) ) {
			echo '<option value="'. $post->ID .'" '. selected( $post->ID, $featured ) .'>'. $post->post_title .'</option>';
		}
	}
	echo '</select>';
}
?>
